/*
 * #%L
 * Reef DB :: Core
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2014 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */
//
/**
 * @author Generated on 06/23/2016 16:36:41+0200 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige2.core::vo::administration::user::DepartmentVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige2.core.vo.administration.user;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Date;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Liste les départements ou services auxquels sont rattachés les agents
 */
public class DepartmentVO
    implements Serializable, Comparable<DepartmentVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 4776030081060966098L;

    // Class attributes
    /**
     * Identifiant interne d'un service
     */
    protected Integer depId;
    /**
     * Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut
     * obligatoire dans LDAP).
     */
    protected String depCd;
    /**
     * Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description
     * car les infos venant de LDAP dépassent les 100 caractères)
     */
    protected String depNm;
    /**
     * Description issue de l'activité LDAP
     */
    protected String depDc;
    /**
     * Mail associé au service
     */
    protected String depEMail;
    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     */
    protected String depAddress;
    /**
     * Les téléphones du service.
     */
    protected String depPhone;
    /**
     * Oui, si le service est présent dans le LDAP
     */
    protected String depLdapPresent;
    /**
     * Date de création de l'objet
     */
    protected Date depCreationDt;
    /**
     * Date de modification de l'objet
     */
    protected Timestamp updateDt;
    /**
     * Code de l'état de l'objet (actif ou inactif)
     */
    protected String statusCd;
    /** TODO: Model Documentation for attribute parentDepartmentId */
    protected Integer parentDepartmentId;

    // Class associationEnds
    /** TODO: Model Documentation for attribute privileges */
    protected PrivilegeVO[] privileges;

    /** Default Constructor with no properties */
    public DepartmentVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param depIdIn Integer Identifiant interne d'un service
     * @param depCdIn String Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut obligatoire dans
LDAP).
     * @param depNmIn String Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description car
les infos venant de LDAP dépassent les 100 caractères)
     * @param statusCdIn String Code de l'état de l'objet (actif ou inactif)
     */
    public DepartmentVO(final Integer depIdIn, final String depCdIn, final String depNmIn, final String statusCdIn)
    {
        this.depId = depIdIn;
        this.depCd = depCdIn;
        this.depNm = depNmIn;
        this.statusCd = statusCdIn;
    }

    /**
     * Constructor with all properties
     * @param depIdIn Integer
     * @param depCdIn String
     * @param depNmIn String
     * @param depDcIn String
     * @param depEMailIn String
     * @param depAddressIn String
     * @param depPhoneIn String
     * @param depLdapPresentIn String
     * @param depCreationDtIn Date
     * @param updateDtIn Timestamp
     * @param statusCdIn String
     * @param parentDepartmentIdIn Integer
     * @param privilegesIn PrivilegeVO[]
     */
    public DepartmentVO(final Integer depIdIn, final String depCdIn, final String depNmIn, final String depDcIn, final String depEMailIn, final String depAddressIn, final String depPhoneIn, final String depLdapPresentIn, final Date depCreationDtIn, final Timestamp updateDtIn, final String statusCdIn, final Integer parentDepartmentIdIn, final PrivilegeVO[] privilegesIn)
    {
        this.depId = depIdIn;
        this.depCd = depCdIn;
        this.depNm = depNmIn;
        this.depDc = depDcIn;
        this.depEMail = depEMailIn;
        this.depAddress = depAddressIn;
        this.depPhone = depPhoneIn;
        this.depLdapPresent = depLdapPresentIn;
        this.depCreationDt = depCreationDtIn;
        this.updateDt = updateDtIn;
        this.statusCd = statusCdIn;
        this.parentDepartmentId = parentDepartmentIdIn;
        this.privileges = privilegesIn;
    }

    /**
     * Copies constructor from other DepartmentVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public DepartmentVO(final DepartmentVO otherBean)
    {
        this.depId = otherBean.getDepId();
        this.depCd = otherBean.getDepCd();
        this.depNm = otherBean.getDepNm();
        this.depDc = otherBean.getDepDc();
        this.depEMail = otherBean.getDepEMail();
        this.depAddress = otherBean.getDepAddress();
        this.depPhone = otherBean.getDepPhone();
        this.depLdapPresent = otherBean.getDepLdapPresent();
        this.depCreationDt = otherBean.getDepCreationDt();
        this.updateDt = otherBean.getUpdateDt();
        this.statusCd = otherBean.getStatusCd();
        this.parentDepartmentId = otherBean.getParentDepartmentId();
        this.privileges = otherBean.getPrivileges();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final DepartmentVO otherBean)
    {
        if (null != otherBean)
        {
            this.setDepId(otherBean.getDepId());
            this.setDepCd(otherBean.getDepCd());
            this.setDepNm(otherBean.getDepNm());
            this.setDepDc(otherBean.getDepDc());
            this.setDepEMail(otherBean.getDepEMail());
            this.setDepAddress(otherBean.getDepAddress());
            this.setDepPhone(otherBean.getDepPhone());
            this.setDepLdapPresent(otherBean.getDepLdapPresent());
            this.setDepCreationDt(otherBean.getDepCreationDt());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setStatusCd(otherBean.getStatusCd());
            this.setParentDepartmentId(otherBean.getParentDepartmentId());
            this.setPrivileges(otherBean.getPrivileges());
        }
    }

    /**
     * Identifiant interne d'un service
     * Get the depId Attribute
     * @return depId Integer
     */
    public Integer getDepId()
    {
        return this.depId;
    }

    /**
     * Identifiant interne d'un service
     * @param value Integer
     */
    public void setDepId(final Integer value)
    {
        this.depId = value;
    }

    /**
     * Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut
     * obligatoire dans LDAP).
     * Get the depCd Attribute
     * @return depCd String
     */
    public String getDepCd()
    {
        return this.depCd;
    }

    /**
     * Code (sigle dans LDAP : identifie de manière unique un service dans LDAP, attribut
     * obligatoire dans LDAP).
     * @param value String
     */
    public void setDepCd(final String value)
    {
        this.depCd = value;
    }

    /**
     * Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description
     * car les infos venant de LDAP dépassent les 100 caractères)
     * Get the depNm Attribute
     * @return depNm String
     */
    public String getDepNm()
    {
        return this.depNm;
    }

    /**
     * Libellé du service issue de l'intitulé dans le LDAP si existant (taillé comme une description
     * car les infos venant de LDAP dépassent les 100 caractères)
     * @param value String
     */
    public void setDepNm(final String value)
    {
        this.depNm = value;
    }

    /**
     * Description issue de l'activité LDAP
     * Get the depDc Attribute
     * @return depDc String
     */
    public String getDepDc()
    {
        return this.depDc;
    }

    /**
     * Description issue de l'activité LDAP
     * @param value String
     */
    public void setDepDc(final String value)
    {
        this.depDc = value;
    }

    /**
     * Mail associé au service
     * Get the depEMail Attribute
     * @return depEMail String
     */
    public String getDepEMail()
    {
        return this.depEMail;
    }

    /**
     * Mail associé au service
     * @param value String
     */
    public void setDepEMail(final String value)
    {
        this.depEMail = value;
    }

    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * Get the depAddress Attribute
     * @return depAddress String
     */
    public String getDepAddress()
    {
        return this.depAddress;
    }

    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * @param value String
     */
    public void setDepAddress(final String value)
    {
        this.depAddress = value;
    }

    /**
     * Les téléphones du service.
     * Get the depPhone Attribute
     * @return depPhone String
     */
    public String getDepPhone()
    {
        return this.depPhone;
    }

    /**
     * Les téléphones du service.
     * @param value String
     */
    public void setDepPhone(final String value)
    {
        this.depPhone = value;
    }

    /**
     * Oui, si le service est présent dans le LDAP
     * Get the depLdapPresent Attribute
     * @return depLdapPresent String
     */
    public String getDepLdapPresent()
    {
        return this.depLdapPresent;
    }

    /**
     * Oui, si le service est présent dans le LDAP
     * @param value String
     */
    public void setDepLdapPresent(final String value)
    {
        this.depLdapPresent = value;
    }

    /**
     * Date de création de l'objet
     * Get the depCreationDt Attribute
     * @return depCreationDt Date
     */
    public Date getDepCreationDt()
    {
        return this.depCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param value Date
     */
    public void setDepCreationDt(final Date value)
    {
        this.depCreationDt = value;
    }

    /**
     * Date de modification de l'objet
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * Get the statusCd Attribute
     * @return statusCd String
     */
    public String getStatusCd()
    {
        return this.statusCd;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * @param value String
     */
    public void setStatusCd(final String value)
    {
        this.statusCd = value;
    }

    /**
     * TODO: Model Documentation for attribute parentDepartmentId
     * Get the parentDepartmentId Attribute
     * @return parentDepartmentId Integer
     */
    public Integer getParentDepartmentId()
    {
        return this.parentDepartmentId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setParentDepartmentId(final Integer value)
    {
        this.parentDepartmentId = value;
    }

    /**
     * TODO: Model Documentation for association privileges
     * Get the privileges Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.privileges PrivilegeVO[]
     */
    public PrivilegeVO[] getPrivileges()
    {
        return this.privileges;
    }

    /**
     * Sets the privileges
     * @param value PrivilegeVO[]
     */
    public void setPrivileges(PrivilegeVO[] value)
    {
        this.privileges = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        DepartmentVO rhs = (DepartmentVO) object;
        return new EqualsBuilder()
            .append(this.getDepId(), rhs.getDepId())
            .append(this.getDepCd(), rhs.getDepCd())
            .append(this.getDepNm(), rhs.getDepNm())
            .append(this.getDepDc(), rhs.getDepDc())
            .append(this.getDepEMail(), rhs.getDepEMail())
            .append(this.getDepAddress(), rhs.getDepAddress())
            .append(this.getDepPhone(), rhs.getDepPhone())
            .append(this.getDepLdapPresent(), rhs.getDepLdapPresent())
            .append(this.getDepCreationDt(), rhs.getDepCreationDt())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getStatusCd(), rhs.getStatusCd())
            .append(this.getParentDepartmentId(), rhs.getParentDepartmentId())
            .append(this.getPrivileges(), rhs.getPrivileges())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final DepartmentVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getDepId(), object.getDepId())
            .append(this.getDepCd(), object.getDepCd())
            .append(this.getDepNm(), object.getDepNm())
            .append(this.getDepDc(), object.getDepDc())
            .append(this.getDepEMail(), object.getDepEMail())
            .append(this.getDepAddress(), object.getDepAddress())
            .append(this.getDepPhone(), object.getDepPhone())
            .append(this.getDepLdapPresent(), object.getDepLdapPresent())
            .append(this.getDepCreationDt(), object.getDepCreationDt())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getStatusCd(), object.getStatusCd())
            .append(this.getParentDepartmentId(), object.getParentDepartmentId())
            .append(this.getPrivileges(), object.getPrivileges())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getDepId())
            .append(this.getDepCd())
            .append(this.getDepNm())
            .append(this.getDepDc())
            .append(this.getDepEMail())
            .append(this.getDepAddress())
            .append(this.getDepPhone())
            .append(this.getDepLdapPresent())
            .append(this.getDepCreationDt())
            .append(this.getUpdateDt())
            .append(this.getStatusCd())
            .append(this.getParentDepartmentId())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getPrivileges())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("depId", this.getDepId())
            .append("depCd", this.getDepCd())
            .append("depNm", this.getDepNm())
            .append("depDc", this.getDepDc())
            .append("depEMail", this.getDepEMail())
            .append("depAddress", this.getDepAddress())
            .append("depPhone", this.getDepPhone())
            .append("depLdapPresent", this.getDepLdapPresent())
            .append("depCreationDt", this.getDepCreationDt())
            .append("updateDt", this.getUpdateDt())
            .append("statusCd", this.getStatusCd())
            .append("parentDepartmentId", this.getParentDepartmentId())
            .append("privileges", this.getPrivileges())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // DepartmentVO value-object java merge-point
}